'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var AutoCompleteItem = function (_React$Component) {
  _inherits(AutoCompleteItem, _React$Component);

  function AutoCompleteItem() {
    var _temp, _this, _ret;

    _classCallCheck(this, AutoCompleteItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.handleClick = function (event) {
      var _this$props = _this.props,
          itemData = _this$props.itemData,
          onSelect = _this$props.onSelect;

      onSelect && onSelect(itemData, event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  AutoCompleteItem.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        onKeyDown = _props.onKeyDown,
        focus = _props.focus,
        children = _props.children,
        className = _props.className,
        classPrefix = _props.classPrefix,
        renderItem = _props.renderItem,
        itemData = _props.itemData,
        rest = _objectWithoutProperties(_props, ['onKeyDown', 'focus', 'children', 'className', 'classPrefix', 'renderItem', 'itemData']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, (_classNames = {}, _classNames[addPrefix('focus')] = focus, _classNames));

    var unhandled = (0, _utils.getUnhandledProps)(AutoCompleteItem, rest);

    return React.createElement(
      'li',
      _extends({}, unhandled, { className: className, role: 'menuitem' }),
      React.createElement(
        'a',
        {
          className: classes,
          tabIndex: -1,
          role: 'button',
          onKeyDown: onKeyDown,
          onClick: this.handleClick
        },
        renderItem ? renderItem(itemData) : children
      )
    );
  };

  return AutoCompleteItem;
}(React.Component);

AutoCompleteItem.handledProps = ['children', 'className', 'classPrefix', 'focus', 'itemData', 'onKeyDown', 'onSelect', 'renderItem'];
AutoCompleteItem.propTypes = {
  classPrefix: _propTypes2.default.string,
  itemData: _propTypes2.default.shape({
    label: function label(props, propName, componentName) {
      if (!Object.prototype.hasOwnProperty.call(props, propName)) {
        throw new Error('Prop `' + propName + '` has type \'any\' or \'mixed\', but was not provided to `' + componentName + '`. Pass undefined or any other value.');
      }
    },
    value: function value(props, propName, componentName) {
      if (!Object.prototype.hasOwnProperty.call(props, propName)) {
        throw new Error('Prop `' + propName + '` has type \'any\' or \'mixed\', but was not provided to `' + componentName + '`. Pass undefined or any other value.');
      }
    }
  }).isRequired,
  onSelect: _propTypes2.default.func,
  onKeyDown: _propTypes2.default.func,
  focus: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  renderItem: _propTypes2.default.func
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'auto-complete-item'
})(AutoCompleteItem);