'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _setStatic = require('recompose/setStatic');

var _setStatic2 = _interopRequireDefault(_setStatic);

var _setDisplayName = require('recompose/setDisplayName');

var _setDisplayName2 = _interopRequireDefault(_setDisplayName);

var _Modal = require('./Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _ModalBody = require('./ModalBody');

var _ModalBody2 = _interopRequireDefault(_ModalBody);

var _ModalHeader = require('./ModalHeader');

var _ModalHeader2 = _interopRequireDefault(_ModalHeader);

var _ModalTitle = require('./ModalTitle');

var _ModalTitle2 = _interopRequireDefault(_ModalTitle);

var _ModalFooter = require('./ModalFooter');

var _ModalFooter2 = _interopRequireDefault(_ModalFooter);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Drawer = function (_React$Component) {
  _inherits(Drawer, _React$Component);

  function Drawer() {
    _classCallCheck(this, Drawer);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Drawer.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        show = _props.show,
        full = _props.full,
        className = _props.className,
        placement = _props.placement,
        classPrefix = _props.classPrefix,
        props = _objectWithoutProperties(_props, ['show', 'full', 'className', 'placement', 'classPrefix']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(addPrefix(placement), className, (_classNames = {}, _classNames[addPrefix('full')] = full, _classNames));

    return React.createElement(_Modal2.default, _extends({}, props, { drawer: true, classPrefix: classPrefix, className: classes, show: show }));
  };

  return Drawer;
}(React.Component);

Drawer.defaultProps = {
  placement: 'right'
};
Drawer.handledProps = ['children', 'className', 'classPrefix', 'full', 'placement', 'show'];
Drawer.propTypes = {
  classPrefix: _propTypes2.default.string.isRequired,
  placement: _propTypes2.default.oneOf(['top', 'right', 'bottom', 'left']),
  show: _propTypes2.default.bool,
  full: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string
};


var EnhancedDrawer = (0, _utils.defaultProps)({
  classPrefix: 'drawer'
})(Drawer);

var EnhancedBody = (0, _utils.defaultProps)({ classPrefix: 'drawer-body' })(_ModalBody2.default);

(0, _setStatic2.default)('Body', (0, _setDisplayName2.default)('Body')(EnhancedBody))(EnhancedDrawer);
(0, _setStatic2.default)('Header', (0, _utils.defaultProps)({ classPrefix: 'drawer-header' })(_ModalHeader2.default))(EnhancedDrawer);
(0, _setStatic2.default)('Title', (0, _utils.defaultProps)({ classPrefix: 'drawer-title' })(_ModalTitle2.default))(EnhancedDrawer);
(0, _setStatic2.default)('Footer', (0, _utils.defaultProps)({ classPrefix: 'drawer-footer' })(_ModalFooter2.default))(EnhancedDrawer);

exports.default = EnhancedDrawer;