'use strict';

exports.__esModule = true;

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('./utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var ErrorMessage = function (_React$Component) {
  _inherits(ErrorMessage, _React$Component);

  function ErrorMessage() {
    _classCallCheck(this, ErrorMessage);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  ErrorMessage.prototype.render = function render() {
    var _classNames, _classNames2;

    var controlId = (0, _get3.default)(this.context, 'formGroup.controlId');

    var _props = this.props,
        className = _props.className,
        _props$htmlFor = _props.htmlFor,
        htmlFor = _props$htmlFor === undefined ? controlId : _props$htmlFor,
        show = _props.show,
        classPrefix = _props.classPrefix,
        children = _props.children,
        placement = _props.placement,
        props = _objectWithoutProperties(_props, ['className', 'htmlFor', 'show', 'classPrefix', 'children', 'placement']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var wrapClasses = (0, _classnames2.default)(addPrefix('wrapper'), className, (_classNames = {}, _classNames[addPrefix('placement-' + (0, _kebabCase3.default)(placement))] = placement, _classNames));
    var classes = (0, _classnames2.default)(classPrefix, (_classNames2 = {}, _classNames2[addPrefix('show')] = show, _classNames2));

    return React.createElement(
      'div',
      _extends({}, props, { className: wrapClasses }),
      React.createElement(
        'div',
        { className: classes, htmlFor: htmlFor },
        React.createElement('span', { className: addPrefix('arrow') }),
        React.createElement(
          'span',
          { className: addPrefix('inner') },
          children
        )
      )
    );
  };

  return ErrorMessage;
}(React.Component);

ErrorMessage.contextTypes = {
  formGroup: _propTypes2.default.object
};
ErrorMessage.handledProps = ['children', 'className', 'classPrefix', 'htmlFor', 'placement', 'show'];
ErrorMessage.propTypes = {
  htmlFor: _propTypes2.default.string,
  show: _propTypes2.default.bool,
  classPrefix: _propTypes2.default.string.isRequired,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  placement: _propTypes2.default.oneOf(['bottomLeft', 'bottomRight', 'topLeft', 'topRight', 'leftTop', 'rightTop', 'leftBottom', 'rightBottom'])
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'error-message'
})(ErrorMessage);