'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var FlexboxGridItem = function (_React$Component) {
  _inherits(FlexboxGridItem, _React$Component);

  function FlexboxGridItem() {
    _classCallCheck(this, FlexboxGridItem);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  FlexboxGridItem.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        className = _props.className,
        classPrefix = _props.classPrefix,
        colspan = _props.colspan,
        order = _props.order,
        props = _objectWithoutProperties(_props, ['className', 'classPrefix', 'colspan', 'order']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, className, addPrefix(colspan), (_classNames = {}, _classNames[addPrefix('order-' + order)] = order, _classNames));

    return React.createElement('div', _extends({}, props, { className: classes }));
  };

  return FlexboxGridItem;
}(React.Component);

FlexboxGridItem.defaultProps = {
  colspan: 0,
  order: 0
};
FlexboxGridItem.handledProps = ['className', 'classPrefix', 'colspan', 'order'];
FlexboxGridItem.propTypes = {
  className: _propTypes2.default.string,
  colspan: _propTypes2.default.number.isRequired,
  order: _propTypes2.default.number.isRequired,
  classPrefix: _propTypes2.default.string.isRequired
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'flex-box-grid-item'
})(FlexboxGridItem);