'use strict';

exports.__esModule = true;

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Whisper = require('./Whisper');

var _Whisper2 = _interopRequireDefault(_Whisper);

var _utils = require('./utils');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var HelpBlock = function (_React$Component) {
  _inherits(HelpBlock, _React$Component);

  function HelpBlock() {
    _classCallCheck(this, HelpBlock);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  HelpBlock.prototype.render = function render() {
    var _classNames;

    var controlId = (0, _get3.default)(this.context, 'formGroup.controlId');

    var _props = this.props,
        className = _props.className,
        tooltip = _props.tooltip,
        children = _props.children,
        _props$htmlFor = _props.htmlFor,
        htmlFor = _props$htmlFor === undefined ? controlId : _props$htmlFor,
        classPrefix = _props.classPrefix,
        props = _objectWithoutProperties(_props, ['className', 'tooltip', 'children', 'htmlFor', 'classPrefix']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, className, (_classNames = {}, _classNames[addPrefix('tooltip')] = tooltip, _classNames));

    if (tooltip) {
      return React.createElement(
        _Whisper2.default,
        { placement: 'topRight', speaker: React.createElement(
            _Tooltip2.default,
            null,
            children
          ) },
        React.createElement(
          'span',
          _extends({ className: classes }, props),
          React.createElement(_Icon2.default, { icon: 'question-circle-o' })
        )
      );
    }

    return React.createElement(
      'span',
      _extends({}, props, { className: classes, htmlFor: htmlFor }),
      children
    );
  };

  return HelpBlock;
}(React.Component);

HelpBlock.contextTypes = {
  formGroup: _propTypes2.default.object
};
HelpBlock.handledProps = ['children', 'className', 'classPrefix', 'htmlFor', 'tooltip'];
HelpBlock.propTypes = {
  className: _propTypes2.default.string,
  htmlFor: _propTypes2.default.string,
  tooltip: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  classPrefix: _propTypes2.default.string.isRequired
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'help-block'
})(HelpBlock);