'use strict';

exports.__esModule = true;

var _Icon$propTypes;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('./utils');

var _TypeDefinition = require('./utils/TypeDefinition');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Icon = function (_React$Component) {
  _inherits(Icon, _React$Component);

  function Icon() {
    _classCallCheck(this, Icon);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Icon.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        className = _props.className,
        classPrefix = _props.classPrefix,
        icon = _props.icon,
        size = _props.size,
        fixedWidth = _props.fixedWidth,
        spin = _props.spin,
        pulse = _props.pulse,
        rotate = _props.rotate,
        flip = _props.flip,
        stack = _props.stack,
        svgStyle = _props.svgStyle,
        Component = _props.componentClass,
        props = _objectWithoutProperties(_props, ['className', 'classPrefix', 'icon', 'size', 'fixedWidth', 'spin', 'pulse', 'rotate', 'flip', 'stack', 'svgStyle', 'componentClass']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var isSvgIcon = (typeof icon === 'undefined' ? 'undefined' : _typeof(icon)) === 'object' && icon.id && icon.viewBox;

    var classes = (0, _classnames2.default)(classPrefix, className, (_classNames = {}, _classNames[addPrefix(icon)] = !isSvgIcon, _classNames[addPrefix(size)] = size, _classNames[addPrefix('fw')] = fixedWidth, _classNames[addPrefix('spin')] = spin, _classNames[addPrefix('pulse')] = pulse, _classNames[addPrefix('flip-' + (flip || ''))] = flip, _classNames[addPrefix('rotate-' + (rotate || ''))] = rotate, _classNames[addPrefix('stack-' + (stack || ''))] = stack, _classNames));

    if (isSvgIcon) {
      var svgIcon = icon;
      return React.createElement(
        Component,
        _extends({}, props, { className: classes }),
        React.createElement(
          'svg',
          { style: svgStyle, viewBox: svgIcon.viewBox },
          React.createElement('use', { xlinkHref: '#' + svgIcon.id })
        )
      );
    }

    return React.createElement(Component, _extends({}, props, { className: classes }));
  };

  return Icon;
}(React.Component);

Icon.handledProps = ['className', 'classPrefix', 'componentClass', 'fixedWidth', 'flip', 'icon', 'pulse', 'rotate', 'size', 'spin', 'stack', 'svgStyle'];
Icon.propTypes = (_Icon$propTypes = {
  icon: _propTypes2.default.oneOfType([_propTypes2.default.string, function () {
    return (typeof _TypeDefinition.bpfrpt_proptype_SVGIcon === 'function' ? _TypeDefinition.bpfrpt_proptype_SVGIcon : _propTypes2.default.shape(_TypeDefinition.bpfrpt_proptype_SVGIcon)).apply(this, arguments);
  }]).isRequired,
  className: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string,
  componentClass: function componentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType) : _propTypes2.default.any).apply(this, arguments);
  },
  size: _propTypes2.default.oneOf(['lg', '2x', '3x', '4x', '5x']),
  flip: _propTypes2.default.oneOf(['horizontal', 'vertical']),
  stack: _propTypes2.default.oneOf(['1x', '2x']),
  rotate: _propTypes2.default.number,
  fixedWidth: _propTypes2.default.bool,
  svgStyle: _propTypes2.default.object,
  spin: _propTypes2.default.bool,
  pulse: _propTypes2.default.bool
}, _Icon$propTypes['componentClass'] = function componentClass() {
  return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType).isRequired : _propTypes2.default.any.isRequired).apply(this, arguments);
}, _Icon$propTypes);
exports.default = (0, _utils.defaultProps)({
  componentClass: 'i',
  classPrefix: 'icon'
})(Icon);