'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var ModalDialog = function (_React$Component) {
  _inherits(ModalDialog, _React$Component);

  function ModalDialog() {
    _classCallCheck(this, ModalDialog);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  ModalDialog.prototype.render = function render() {
    var _props = this.props,
        style = _props.style,
        children = _props.children,
        dialogClassName = _props.dialogClassName,
        dialogStyle = _props.dialogStyle,
        classPrefix = _props.classPrefix,
        className = _props.className,
        props = _objectWithoutProperties(_props, ['style', 'children', 'dialogClassName', 'dialogStyle', 'classPrefix', 'className']);

    var modalStyle = _extends({
      display: 'block'
    }, style);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var dialogClasses = (0, _classnames2.default)(addPrefix('dialog'), dialogClassName);

    return React.createElement(
      'div',
      _extends({}, props, {
        title: null,
        role: 'dialog',
        className: (0, _classnames2.default)(classPrefix, className),
        style: modalStyle
      }),
      React.createElement(
        'div',
        { className: dialogClasses, style: dialogStyle },
        React.createElement(
          'div',
          { className: addPrefix('content'), role: 'document' },
          children
        )
      )
    );
  };

  return ModalDialog;
}(React.Component);

ModalDialog.handledProps = ['children', 'className', 'classPrefix', 'dialogClassName', 'dialogStyle', 'style'];
ModalDialog.propTypes = {
  className: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string.isRequired,
  dialogClassName: _propTypes2.default.string,
  style: _propTypes2.default.object,
  dialogStyle: _propTypes2.default.object,
  children: _propTypes2.default.node
};
exports.default = (0, _compose2.default)((0, _utils.withStyleProps)({
  hasSize: true
}), (0, _utils.defaultProps)({
  classPrefix: 'modal'
}))(ModalDialog);