'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var ModalHeader = function (_React$Component) {
  _inherits(ModalHeader, _React$Component);

  function ModalHeader() {
    _classCallCheck(this, ModalHeader);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  ModalHeader.prototype.render = function render() {
    var _props = this.props,
        classPrefix = _props.classPrefix,
        onHide = _props.onHide,
        className = _props.className,
        closeButton = _props.closeButton,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['classPrefix', 'onHide', 'className', 'closeButton', 'children']);

    var classes = (0, _classnames2.default)(classPrefix, className);
    var addPrefix = (0, _utils.prefix)(classPrefix);

    return React.createElement(
      'div',
      _extends({}, props, { className: classes }),
      closeButton && React.createElement(
        'button',
        {
          type: 'button',
          className: addPrefix('close'),
          'aria-label': 'Close',
          onClick: (0, _utils.createChainedFunction)(this.context.onModalHide, onHide)
        },
        React.createElement(
          'span',
          { 'aria-hidden': 'true' },
          '\xD7'
        )
      ),
      children
    );
  };

  return ModalHeader;
}(React.Component);

ModalHeader.contextTypes = {
  onModalHide: _propTypes2.default.func
};
ModalHeader.defaultProps = {
  closeButton: true
};
ModalHeader.handledProps = ['children', 'className', 'classPrefix', 'closeButton', 'onHide'];
ModalHeader.propTypes = {
  classPrefix: _propTypes2.default.string,
  className: _propTypes2.default.string,
  closeButton: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  onHide: _propTypes2.default.func
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'modal-header'
})(ModalHeader);