'use strict';

exports.__esModule = true;

var _isEqual2 = require('lodash/isEqual');

var _isEqual3 = _interopRequireDefault(_isEqual2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _setStatic = require('recompose/setStatic');

var _setStatic2 = _interopRequireDefault(_setStatic);

var _NavItem = require('./NavItem');

var _NavItem2 = _interopRequireDefault(_NavItem);

var _utils = require('./utils');

var _prefix = require('./utils/prefix');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Nav = function (_React$Component) {
  _inherits(Nav, _React$Component);

  function Nav() {
    _classCallCheck(this, Nav);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Nav.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        classPrefix = _props.classPrefix,
        appearance = _props.appearance,
        vertical = _props.vertical,
        justified = _props.justified,
        reversed = _props.reversed,
        pullRight = _props.pullRight,
        className = _props.className,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['classPrefix', 'appearance', 'vertical', 'justified', 'reversed', 'pullRight', 'className', 'children']);

    var _context = this.context,
        navbar = _context.navbar,
        sidenav = _context.sidenav,
        expanded = _context.expanded,
        _context$activeKey = _context.activeKey,
        activeKey = _context$activeKey === undefined ? props.activeKey : _context$activeKey,
        _context$onSelect = _context.onSelect,
        onSelect = _context$onSelect === undefined ? props.onSelect : _context$onSelect;


    var addPrefix = (0, _utils.prefix)(classPrefix);

    var classes = (0, _classnames2.default)(classPrefix, addPrefix(appearance), className, (_classNames = {}, _classNames[_prefix.globalKey + 'navbar-nav'] = navbar, _classNames[_prefix.globalKey + 'navbar-right'] = pullRight, _classNames[_prefix.globalKey + 'sidenav-nav'] = sidenav, _classNames[addPrefix('horizontal')] = navbar || !vertical && !sidenav, _classNames[addPrefix('vertical')] = vertical || sidenav, _classNames[addPrefix('justified')] = justified, _classNames[addPrefix('reversed')] = reversed, _classNames));

    var hasWaterline = appearance !== 'default';

    var items = _utils.ReactChildren.mapCloneElement(children, function (item) {
      var _item$props = item.props,
          eventKey = _item$props.eventKey,
          active = _item$props.active,
          rest = _objectWithoutProperties(_item$props, ['eventKey', 'active']);

      var displayName = (0, _get3.default)(item, ['type', 'displayName']);

      if (displayName === 'NavItem') {
        return _extends({}, rest, {
          onSelect: onSelect,
          hasTooltip: sidenav && !expanded,
          active: (0, _isUndefined3.default)(activeKey) ? active : (0, _isEqual3.default)(activeKey, eventKey)
        });
      } else if (displayName === 'Dropdown') {
        return _extends({}, rest, {
          onSelect: onSelect,
          activeKey: activeKey,
          componentClass: 'li'
        });
      }

      return null;
    });

    var unhandled = (0, _utils.getUnhandledProps)(Nav, props);

    return React.createElement(
      'div',
      _extends({}, unhandled, { className: classes }),
      React.createElement(
        'ul',
        null,
        items
      ),
      hasWaterline && React.createElement('div', { className: addPrefix('waterline') })
    );
  };

  return Nav;
}(React.Component);

Nav.defaultProps = {
  appearance: 'default'
};
Nav.contextTypes = {
  expanded: _propTypes2.default.bool,
  navbar: _propTypes2.default.bool,
  sidenav: _propTypes2.default.bool,
  activeKey: _propTypes2.default.any,
  onSelect: _propTypes2.default.func
};
Nav.handledProps = ['activeKey', 'appearance', 'children', 'className', 'classPrefix', 'justified', 'onSelect', 'pullRight', 'reversed', 'vertical'];
Nav.propTypes = {
  classPrefix: _propTypes2.default.string.isRequired,
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  appearance: _propTypes2.default.oneOf(['default', 'subtle', 'tabs']).isRequired,

  // Reverse Direction of tabs/subtle
  reversed: _propTypes2.default.bool,
  justified: _propTypes2.default.bool,
  vertical: _propTypes2.default.bool,
  pullRight: _propTypes2.default.bool,
  activeKey: _propTypes2.default.any,
  onSelect: _propTypes2.default.func
};


var EnhancedNav = (0, _utils.defaultProps)({
  classPrefix: 'nav'
})(Nav);

(0, _setStatic2.default)('Item', _NavItem2.default)(EnhancedNav);

exports.default = EnhancedNav;