'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _setStatic = require('recompose/setStatic');

var _setStatic2 = _interopRequireDefault(_setStatic);

var _NavbarBody = require('./NavbarBody');

var _NavbarBody2 = _interopRequireDefault(_NavbarBody);

var _NavbarHeader = require('./NavbarHeader');

var _NavbarHeader2 = _interopRequireDefault(_NavbarHeader);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Navbar = function (_React$Component) {
  _inherits(Navbar, _React$Component);

  function Navbar() {
    _classCallCheck(this, Navbar);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Navbar.prototype.getChildContext = function getChildContext() {
    return {
      navbar: this.props.hasChildContext
    };
  };

  Navbar.prototype.render = function render() {
    var _props = this.props,
        className = _props.className,
        Component = _props.componentClass,
        classPrefix = _props.classPrefix,
        appearance = _props.appearance,
        rest = _objectWithoutProperties(_props, ['className', 'componentClass', 'classPrefix', 'appearance']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var unhandled = (0, _utils.getUnhandledProps)(Navbar, rest);
    var classes = (0, _classnames2.default)(classPrefix, addPrefix(appearance), className);

    return React.createElement(Component, _extends({}, unhandled, { className: classes, role: 'navigation' }));
  };

  return Navbar;
}(React.Component);

Navbar.defaultProps = {
  hasChildContext: true,
  appearance: 'default'
};
Navbar.childContextTypes = {
  navbar: _propTypes2.default.bool
};
Navbar.handledProps = ['appearance', 'className', 'classPrefix', 'componentClass', 'hasChildContext'];
Navbar.propTypes = {
  classPrefix: _propTypes2.default.string,
  className: _propTypes2.default.string,
  appearance: _propTypes2.default.oneOf(['default', 'inverse', 'subtle']).isRequired,
  componentClass: function componentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType).isRequired : _propTypes2.default.any.isRequired).apply(this, arguments);
  },
  hasChildContext: _propTypes2.default.bool
};


var EnhancedNavbar = (0, _utils.defaultProps)({
  componentClass: 'div',
  classPrefix: 'navbar'
})(Navbar);

(0, _setStatic2.default)('Header', _NavbarHeader2.default)(EnhancedNavbar);
(0, _setStatic2.default)('Body', _NavbarBody2.default)(EnhancedNavbar);

exports.default = EnhancedNavbar;