'use strict';

exports.__esModule = true;

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var PanelGroup = function (_React$Component) {
  _inherits(PanelGroup, _React$Component);

  function PanelGroup(props) {
    _classCallCheck(this, PanelGroup);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = {
      activeKey: props.defaultActiveKey
    };
    return _this;
  }

  PanelGroup.prototype.getActiveKey = function getActiveKey() {
    var activeKey = this.props.activeKey;

    return (0, _isUndefined3.default)(activeKey) ? this.state.activeKey : activeKey;
  };

  PanelGroup.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        className = _props.className,
        accordion = _props.accordion,
        bordered = _props.bordered,
        classPrefix = _props.classPrefix,
        children = _props.children,
        onSelect = _props.onSelect,
        rest = _objectWithoutProperties(_props, ['className', 'accordion', 'bordered', 'classPrefix', 'children', 'onSelect']);

    var classes = (0, _classnames2.default)(classPrefix, className, (_classNames = {}, _classNames[this.addPrefix('accordion')] = accordion, _classNames[this.addPrefix('bordered')] = bordered, _classNames));

    var unhandled = (0, _utils.getUnhandledProps)(PanelGroup, rest);

    return React.createElement(
      'div',
      _extends({}, unhandled, { role: accordion ? 'tablist' : undefined, className: classes }),
      _utils.ReactChildren.mapCloneElement(children, this.renderPanel)
    );
  };

  return PanelGroup;
}(React.Component);

PanelGroup.handledProps = ['accordion', 'activeKey', 'bordered', 'children', 'className', 'classPrefix', 'defaultActiveKey', 'onSelect'];
PanelGroup.propTypes = {
  accordion: _propTypes2.default.bool,
  activeKey: _propTypes2.default.any,
  bordered: _propTypes2.default.bool,
  defaultActiveKey: _propTypes2.default.any,
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  classPrefix: _propTypes2.default.string,
  onSelect: _propTypes2.default.func
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.handleSelect = function (activeKey, event) {
    var onSelect = _this2.props.onSelect;

    _this2.setState({ activeKey: activeKey });
    onSelect && onSelect(activeKey, event);
  };

  this.addPrefix = function (name) {
    return (0, _utils.prefix)(_this2.props.classPrefix)(name);
  };

  this.renderPanel = function (child, index) {
    if (!React.isValidElement(child)) {
      return child;
    }
    var accordion = _this2.props.accordion;

    var activeKey = _this2.getActiveKey();
    var props = {
      key: child.key ? child.key : index,
      ref: child.ref
    };

    if (accordion) {
      return _extends({}, props, {
        headerRole: 'tab',
        panelRole: 'tabpanel',
        collapsible: true,
        expanded: (0, _isUndefined3.default)(activeKey) ? child.props.expanded : child.props.eventKey === activeKey,
        onSelect: _this2.handleSelect
      });
    }

    return props;
  };
};

exports.default = (0, _utils.defaultProps)({
  classPrefix: 'panel-group'
})(PanelGroup);