'use strict';

exports.__esModule = true;

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Popover = function (_React$Component) {
  _inherits(Popover, _React$Component);

  function Popover() {
    _classCallCheck(this, Popover);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Popover.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        classPrefix = _props.classPrefix,
        title = _props.title,
        children = _props.children,
        style = _props.style,
        visible = _props.visible,
        placement = _props.placement,
        className = _props.className,
        full = _props.full,
        onMouseLeave = _props.onMouseLeave,
        onMouseEnter = _props.onMouseEnter;


    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, className, (_classNames = {}, _classNames[addPrefix('placement-' + (0, _kebabCase3.default)(placement || ''))] = placement, _classNames[addPrefix('full')] = full, _classNames));

    var styles = _extends({
      display: 'block',
      opacity: visible ? 1 : undefined
    }, style);

    return React.createElement(
      'div',
      {
        onMouseLeave: onMouseLeave,
        onMouseEnter: onMouseEnter,
        className: classes,
        style: styles
      },
      React.createElement('div', { className: 'arrow' }),
      title ? React.createElement(
        'h3',
        { className: addPrefix('title') },
        title
      ) : null,
      React.createElement(
        'div',
        { className: addPrefix('content') },
        children
      )
    );
  };

  return Popover;
}(React.Component);

Popover.handledProps = ['children', 'className', 'classPrefix', 'full', 'onMouseEnter', 'onMouseLeave', 'placement', 'style', 'title', 'visible'];
Popover.propTypes = {
  placement: _propTypes2.default.oneOfType([_propTypes2.default.oneOf(['top', 'right', 'bottom', 'left']), _propTypes2.default.oneOf(['bottomLeft', 'bottomRight', 'topLeft', 'topRight', 'leftTop', 'rightTop', 'leftBottom', 'rightBottom', 'auto', 'autoVerticalLeft', 'autoVerticalRight', 'autoHorizontalTop', 'autoHorizontalBottom'])]),
  classPrefix: _propTypes2.default.string.isRequired,
  children: _propTypes2.default.node,
  title: _propTypes2.default.node,
  style: _propTypes2.default.object,
  visible: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  full: _propTypes2.default.bool,
  onMouseLeave: _propTypes2.default.func,
  onMouseEnter: _propTypes2.default.func
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'popover'
})(Popover);