'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _IconButton = require('./IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var SidenavToggle = function (_React$Component) {
  _inherits(SidenavToggle, _React$Component);

  function SidenavToggle() {
    var _temp, _this, _ret;

    _classCallCheck(this, SidenavToggle);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.handleToggle = function (event) {
      var _this$props = _this.props,
          onToggle = _this$props.onToggle,
          expanded = _this$props.expanded;

      onToggle && onToggle(!expanded, event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  SidenavToggle.prototype.render = function render() {
    var _props = this.props,
        onToggle = _props.onToggle,
        expanded = _props.expanded,
        className = _props.className,
        classPrefix = _props.classPrefix,
        props = _objectWithoutProperties(_props, ['onToggle', 'expanded', 'className', 'classPrefix']);

    var classes = (0, _classnames2.default)(classPrefix, className, {
      collapsed: !expanded
    });

    return React.createElement(
      'div',
      _extends({}, props, { className: classes }),
      React.createElement(_IconButton2.default, {
        appearance: 'default',
        icon: React.createElement(_Icon2.default, { icon: expanded ? 'angle-right' : 'angle-left' }),
        onClick: this.handleToggle
      })
    );
  };

  return SidenavToggle;
}(React.Component);

SidenavToggle.handledProps = ['className', 'classPrefix', 'expanded', 'onToggle'];
SidenavToggle.propTypes = {
  classPrefix: _propTypes2.default.string,
  className: _propTypes2.default.string,
  expanded: _propTypes2.default.bool,
  onToggle: _propTypes2.default.func
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'sidenav-toggle'
})(SidenavToggle);