'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var StepItem = function (_React$Component) {
  _inherits(StepItem, _React$Component);

  function StepItem() {
    _classCallCheck(this, StepItem);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  StepItem.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        className = _props.className,
        classPrefix = _props.classPrefix,
        style = _props.style,
        itemWidth = _props.itemWidth,
        status = _props.status,
        icon = _props.icon,
        stepNumber = _props.stepNumber,
        description = _props.description,
        title = _props.title,
        rest = _objectWithoutProperties(_props, ['className', 'classPrefix', 'style', 'itemWidth', 'status', 'icon', 'stepNumber', 'description', 'title']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, (_classNames = {}, _classNames[addPrefix('custom')] = icon, _classNames), addPrefix('status-' + status), className);

    var styles = _extends({
      width: itemWidth
    }, style);

    var contentNode = title || description ? React.createElement(
      'div',
      { className: addPrefix('content') },
      title && React.createElement(
        'div',
        { className: addPrefix('title') },
        title
      ),
      description && React.createElement(
        'div',
        { className: addPrefix('description') },
        description
      )
    ) : null;

    var iconNode = React.createElement(
      'span',
      { className: addPrefix(['icon', 'icon-' + status]) },
      stepNumber
    );

    if (icon) {
      iconNode = React.createElement(
        'span',
        { className: addPrefix('icon') },
        icon
      );
    }

    return React.createElement(
      'div',
      _extends({}, rest, { className: classes, style: styles }),
      React.createElement('div', { className: addPrefix('tail') }),
      React.createElement(
        'div',
        { className: addPrefix(['icon-wrapper', icon ? 'custom-icon' : '']) },
        iconNode
      ),
      contentNode
    );
  };

  return StepItem;
}(React.Component);

StepItem.handledProps = ['className', 'classPrefix', 'description', 'icon', 'itemWidth', 'status', 'stepNumber', 'style', 'title'];
StepItem.propTypes = {
  className: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string,
  style: _propTypes2.default.object,
  itemWidth: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  status: _propTypes2.default.oneOf(['finish', 'wait', 'process', 'error']),
  icon: _propTypes2.default.node,
  stepNumber: _propTypes2.default.number,
  description: _propTypes2.default.node,
  title: _propTypes2.default.node
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'steps-item'
})(StepItem);