'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _setStatic = require('recompose/setStatic');

var _setStatic2 = _interopRequireDefault(_setStatic);

var _StepItem = require('./StepItem');

var _StepItem2 = _interopRequireDefault(_StepItem);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Steps = function (_React$Component) {
  _inherits(Steps, _React$Component);

  function Steps() {
    _classCallCheck(this, Steps);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Steps.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        classPrefix = _props.classPrefix,
        className = _props.className,
        children = _props.children,
        vertical = _props.vertical,
        small = _props.small,
        current = _props.current,
        currentStatus = _props.currentStatus,
        rest = _objectWithoutProperties(_props, ['classPrefix', 'className', 'children', 'vertical', 'small', 'current', 'currentStatus']);

    var addPrefix = (0, _utils.prefix)(classPrefix);
    var horizontal = !vertical;
    var classes = (0, _classnames2.default)(classPrefix, className, (_classNames = {
      'ie-polyfill': horizontal && _utils.isIE9
    }, _classNames[addPrefix('small')] = small, _classNames[addPrefix('vertical')] = vertical, _classNames[addPrefix('horizontal')] = horizontal, _classNames));

    var count = children.length;
    var items = _utils.ReactChildren.mapCloneElement(children, function (item, index) {
      var _itemStyles;

      var itemStyles = (_itemStyles = {}, _itemStyles[_utils.isIE10 ? 'msFlexPreferredSize' : 'flexBasis'] = index < count - 1 ? 100 / (count - 1) + '%' : undefined, _itemStyles.maxWidth = index === count - 1 ? 100 / count + '%' : undefined, _itemStyles);
      var itemProps = _extends({
        stepNumber: index + 1,
        status: 'wait',
        style: horizontal ? itemStyles : undefined
      }, item.props);

      // fix tail color
      if (currentStatus === 'error' && index === current - 1) {
        itemProps.className = addPrefix('next-error');
      }

      if (!item.props.status) {
        if (index === current) {
          itemProps.status = currentStatus;
        } else if (index < current) {
          itemProps.status = 'finish';
        }
      }

      return itemProps;
    });

    return React.createElement(
      'div',
      _extends({}, rest, { className: classes }),
      items
    );
  };

  return Steps;
}(React.Component);

Steps.defaultProps = {
  currentStatus: 'process',
  current: 0
};
Steps.handledProps = ['children', 'className', 'classPrefix', 'current', 'currentStatus', 'small', 'vertical'];
Steps.propTypes = {
  classPrefix: _propTypes2.default.string.isRequired,
  vertical: _propTypes2.default.bool,
  small: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  children: function children() {
    return (typeof (React.ChildrenArray == null ? {} : React.ChildrenArray) === 'function' ? _propTypes2.default.instanceOf(React.ChildrenArray == null ? {} : React.ChildrenArray).isRequired : _propTypes2.default.any.isRequired).apply(this, arguments);
  },
  current: _propTypes2.default.number.isRequired,
  currentStatus: _propTypes2.default.oneOf(['finish', 'wait', 'process', 'error'])
};


var EnhancedSteps = (0, _utils.defaultProps)({
  classPrefix: 'steps'
})(Steps);

(0, _setStatic2.default)('Item', _StepItem2.default)(EnhancedSteps);

exports.default = EnhancedSteps;