'use strict';

exports.__esModule = true;

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Toggle = function (_React$Component) {
  _inherits(Toggle, _React$Component);

  function Toggle(props) {
    _classCallCheck(this, Toggle);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var checked = props.checked,
        defaultChecked = props.defaultChecked;

    _this.state = {
      checked: (0, _isUndefined3.default)(checked) ? defaultChecked : checked
    };
    return _this;
  }

  Toggle.prototype.getCheckedStatus = function getCheckedStatus() {
    var checked = this.props.checked;

    return (0, _isUndefined3.default)(checked) ? this.state.checked : checked;
  };

  Toggle.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        disabled = _props.disabled,
        className = _props.className,
        onChange = _props.onChange,
        checkedChildren = _props.checkedChildren,
        unCheckedChildren = _props.unCheckedChildren,
        classPrefix = _props.classPrefix,
        rest = _objectWithoutProperties(_props, ['disabled', 'className', 'onChange', 'checkedChildren', 'unCheckedChildren', 'classPrefix']);

    var checked = this.getCheckedStatus();
    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, className, (_classNames = {}, _classNames[addPrefix('checked')] = checked, _classNames[addPrefix('disabled')] = disabled, _classNames));

    var inner = checked ? checkedChildren : unCheckedChildren;
    var unhandled = (0, _utils.getUnhandledProps)(Toggle, rest);

    return React.createElement(
      'span',
      _extends({}, unhandled, {
        className: classes,
        role: 'button',
        tabIndex: -1,
        onClick: this.handleChange
      }),
      React.createElement(
        'span',
        { className: addPrefix('inner') },
        inner
      )
    );
  };

  return Toggle;
}(React.Component);

Toggle.handledProps = ['checked', 'checkedChildren', 'className', 'classPrefix', 'defaultChecked', 'disabled', 'onChange', 'unCheckedChildren'];
Toggle.propTypes = {
  disabled: _propTypes2.default.bool,
  checked: _propTypes2.default.bool,
  defaultChecked: _propTypes2.default.bool,
  onChange: _propTypes2.default.func,
  checkedChildren: _propTypes2.default.node,
  unCheckedChildren: _propTypes2.default.node,
  classPrefix: _propTypes2.default.string.isRequired,
  className: _propTypes2.default.string
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.handleChange = function (event) {
    var _props2 = _this2.props,
        onChange = _props2.onChange,
        disabled = _props2.disabled;

    var checked = !_this2.state.checked;

    if (disabled) {
      return;
    }

    _this2.setState({ checked: checked }, function () {
      onChange && onChange(checked, event);
    });
  };
};

exports.default = (0, _compose2.default)((0, _utils.withStyleProps)({
  hasSize: true
}), (0, _utils.defaultProps)({
  classPrefix: 'btn-toggle'
}))(Toggle);