'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _rsuiteIntl = require('rsuite-intl');

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Button = function Button(props) {
  return React.createElement('button', _extends({}, props, { type: 'button' }));
};

Button.handledProps = [];

var UploadTrigger = function (_React$Component) {
  _inherits(UploadTrigger, _React$Component);

  function UploadTrigger() {
    var _temp, _this, _ret;

    _classCallCheck(this, UploadTrigger);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.handleClick = function () {
      !_this.props.disabled && _this.input.click();
    }, _this.bindInputRef = function (ref) {
      _this.input = ref;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  UploadTrigger.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        name = _props.name,
        accept = _props.accept,
        multiple = _props.multiple,
        disabled = _props.disabled,
        onChange = _props.onChange,
        children = _props.children,
        classPrefix = _props.classPrefix,
        className = _props.className,
        innerRef = _props.innerRef,
        rest = _objectWithoutProperties(_props, ['name', 'accept', 'multiple', 'disabled', 'onChange', 'children', 'classPrefix', 'className', 'innerRef']);

    var unhandled = (0, _utils.getUnhandledProps)(UploadTrigger, rest);
    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, className, (_classNames = {}, _classNames[addPrefix('disabled')] = disabled, _classNames));

    var buttonProps = _extends({}, unhandled, {
      className: addPrefix('btn'),
      onClick: this.handleClick
    });

    var trigger = children ? React.cloneElement(React.Children.only(children), buttonProps) : React.createElement(
      Button,
      buttonProps,
      React.createElement(_rsuiteIntl.FormattedMessage, { id: 'upload' })
    );

    return React.createElement(
      'div',
      { className: classes },
      React.createElement('input', {
        type: 'file',
        name: name,
        multiple: multiple,
        disabled: disabled,
        accept: accept,
        ref: (0, _utils.createChainedFunction)(this.bindInputRef, innerRef),
        onChange: onChange
      }),
      trigger
    );
  };

  return UploadTrigger;
}(React.Component);

UploadTrigger.handledProps = ['accept', 'children', 'className', 'classPrefix', 'disabled', 'innerRef', 'multiple', 'name', 'onChange'];
UploadTrigger.propTypes = {
  name: _propTypes2.default.string,
  multiple: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  accept: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  classPrefix: _propTypes2.default.string,
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  innerRef: function innerRef() {
    return (typeof (React.ElementRef == null ? {} : React.ElementRef) === 'function' ? _propTypes2.default.instanceOf(React.ElementRef == null ? {} : React.ElementRef) : _propTypes2.default.any).apply(this, arguments);
  }
};
exports.default = (0, _utils.defaultProps)({
  classPrefix: 'uploader-trigger'
})(UploadTrigger);